/*
 * Definitions.h
 *
 *  Created on: Apr 23, 2014
 *      Author: ed / bs
 */

#ifndef DEFINITIONS_H_
#define DEFINITIONS_H_

	#include "tmc/TMC_Definitions.h"
	#include "tmc/motion/helpers/Types.h"

	typedef struct	// Achtung, Compiler f�gt F�llbytes ein!
	{
		u8 Baudrate;
		u8 SerialModuleAddress;
		u8 SerialHostAddress;
		u8 TelegramPauseTime;
		u8 TMCLProtectionMode;
		u8 TMCLAutostartFlag;
		u8 EEPROMLockFlag;
		u8 ZeroUserVariables;
	} TModuleConfig;

	typedef struct    //Achtung, Compiler f�gt F�llbytes ein!
	{
		u8 uStepResolution;
		u8 uStepInterpolation;
	} TMotorConfig;

	#define SW_VERSION_HIGH 1
	#define SW_VERSION_LOW  0

	#include "hal/modules/SelectModule.h"

	#define RIGHT_MOTOR_DIRECTION	  (u8)0
	#define LEFT_MOTOR_DIRECTION	  (u8)1


#define ADDR_TMCL_USER_VARS 	1818
#define ADDR_HOUR_METER_MINUTES 1810
#define ADDR_IIT_MONITOR		1814


	//extern void tmcl_handleAxisParameter(u8 command);
	extern uint32_t tmcl_handleAxisParameter(uint8_t motor, uint8_t command, uint8_t type, int32_t *value);

	extern void tmcl_handleGlobalParameter(u8 command);
	extern void tmcl_setGlobalParameter();
	extern void tmcl_executeBinaryCommand(u8 *BinaryCommand, u8 *BinaryResult);

	/* expected board specific functions */
	extern void tmcm_initModuleConfig();
	extern void tmcm_initMotorConfig();
	extern void tmcm_initModuleSpecificIO();
	extern void tmcm_initModuleSpecificADC();
	extern void tmcm_initModuleSpecificADCOffsets();

	extern u8 tmcm_getModuleSpecificIOPin(u8 pin);
	extern u8 tmcm_getModuleSpecificIOPinStatus(u8 pin);
	extern void tmcm_clearModuleSpecificIOPin(u8 pin);
	extern void tmcm_setModuleSpecificIOPin(u8 pin);

	extern u32 tmcm_getModuleSpecificADCValue(u8 pin);
	extern u32 tmcm_getModuleSpecificADCOffset(u8 pin);
	extern void tmcm_setModuleSpecificADCOffset(u8 pin, u16 offset);
	extern u32 tmcm_getModuleVoltage();

	extern void tmcm_triggerAdcMeasurement(u32 delay);

	// driver control
	extern void tmcm_enable_driver();
	extern void tmcm_disable_driver();
	extern bool tmcm_get_driver_state();

	void tmcm_set_SPI_CS();
	void tmcm_clear_SPI_CS();


	// Module Configuration
	u8 tmcm_getUStepConfig();
	u8 tmcm_getCurrentSetting();
	void tmcm_configurationControl();
	void tmcm_handlecharger();
	void tmcm_set_led_charge_on();
	void tmcm_set_led_charge_off();
	void tmcm_determine_led_charge();
	bool tmcm_is_charging();

	// LED
	extern void tmcm_set_led_run_off();
	extern void tmcm_set_led_run_on();
	extern void tmcm_toggle_led_run();

	// step dir
	bool tmcm_get_diag_pin();

	void tmcm_set_step_pin();
	void tmcm_clear_step_pin();
	void tmcm_set_dir_pin();
	void tmcm_clear_dir_pin();

	// Reset to Factory Default
	u8 ResetToFactoryDefaultRequested;
	extern void tmcm_checkHardwareReset();
	extern void tmcm_checkResetToDefault();

#endif /* DEFINITIONS_H_ */
