/*
 * SPI.h
 *
 *  Created on: 17.03.2016
 *      Author: bs
 */

#ifndef HAL_COMM_SPI_H_
#define HAL_COMM_SPI_H_

	#include "../../Definitions.h"
	#include "tmc/tmcl/TMCL-Defines.h"

	// SPI devices
	#define SPI_DEV_TMC5130 0

	void spi1_init();
	u8 spi_readWrite(u8 deviceNumber, u8 data, u8 lastTransfer);

	#define TMCM_EEPROM_MAGIC			(u8)0x65	// v1.01

	// constants for the EEPROM
	#define TMCM_ADDR_MODULE_CONFIG (u32)0
	#define TMCM_ADDR_MOTOR_CONFIG 	(u32)64
	#define TMCM_ADDR_SECURITY_CODE	(u32)2043
	#define TMCM_ADDR_EEPROM_MAGIC 	(u32)2047
	#define TMCM_ADDR_TMCL_PROG 	(u32)2048		// start of the EEPROM area for TMCL programs

	void eeprom_initSpi();
	void eeprom_initConfig(/*TModuleConfig *moduleConfig*//*, TMotorConfig *motorConfig*/);
	void eeprom_writeConfigByte(u32 address, u8 Value);
	u8 eeprom_readConfigByte(u32 address);

	void eeprom_eraseTMCLProgram();
	void eeprom_erase();
	u32 eeprom_verifyTMCLCommand(u32 address, TTMCLCommand *TMCLCommand);
	void eeprom_writeTMCLCommand(u32 address, TTMCLCommand *TMCLCommand);
	void eeprom_readTMCLCommand(u32 address, TTMCLCommand *TMCLCommand);

	void eeprom_writeConfigBlock(u32 address, u8 *block, u32 size);
	void eeprom_readConfigBlock(u32 address, u8 *block, u32 size);

#endif /* HAL_COMM_SPI_H_ */
