/*
 * SysTick.c
 *
 *  Created on: 25.04.2014
 *      Author: ed
 */

#include "SysTick.h"

unsigned int sysTickTimer = 0;

#ifdef TMCM_USE_UART_INTERFACE
	extern volatile u32 UARTTransmitDelayTimer;
	extern volatile u32 UARTTimeoutTimer;
	extern volatile u8 UARTTimeoutFlag;
#endif

/* initialize SysTick timer */
void systick_init()
{
#if (BOARD_CPU==MKE02Z164VFM4)
 	SYST_CSR = 0x00U;
 	SYST_RVR = SysTick_RVR_RELOAD(CORE_CLOCK/1000);
 	SYST_CVR = SysTick_CVR_CURRENT(0x00);
 	SYST_CSR = SysTick_CSR_CLKSOURCE_MASK | SysTick_CSR_TICKINT_MASK | SysTick_CSR_ENABLE_MASK;
#else
	#error "systick_init() for BOARD_CPU not supported!"
#endif
}

void systick_deInit()
{
#if (BOARD_CPU==MKE02Z164VFM4)
	SYST_CSR=0;
#else
	#error "systick_deInit() for BOARD_CPU not supported!"
#endif
}


/* get system timer in [ms] */
u32 systick_getTimer()
{
	return sysTickTimer;
}

__attribute__((__used__))
void SysTick_handler(void)
{
	// increase 1ms counter
	sysTickTimer++;

#ifdef TMCM_USE_UART_INTERFACE

	// UART-Empfangstimeout herunterz�hlen
	if(UARTTimeoutTimer > 0)
	{
		UARTTimeoutTimer--;
		if(UARTTimeoutTimer==0) UARTTimeoutFlag=TRUE;
	}

	// UART-Sendeverz�gerung herunterz�hlen
	if(UARTTransmitDelayTimer>0)
		UARTTransmitDelayTimer--;

#endif
}
